diff --git a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktAPI.cs b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktAPI.cs
index 542fcce..be4cd5d 100644
--- a/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktAPI.cs
+++ b/MediaPortal/Source/Extensions/MetadataExtractors/OnlineLibraries/Libraries/Trakt/TraktAPI.cs
@@ -1131,264 +1047,1109 @@ namespace MediaPortal.Extensions.OnlineLibraries.Libraries.Trakt
     /// <summary>
     /// Returns a list of users found using search term
     /// </summary>
-    public static IEnumerable<TraktUser> SearchForUsers(string searchTerm)
+    public static IEnumerable<TraktSearchResult> SearchForUsers(string searchTerm)
     {
-      return SearchForUsers(searchTerm, 30);
+      return SearchUsers(searchTerm, 30);
     }
-    public static IEnumerable<TraktUser> SearchForUsers(string searchTerm, int maxResults)
+
+    public static IEnumerable<TraktSearchResult> SearchUsers(string searchTerm, int maxResults)
     {
-      string response = Transmit(string.Format(TraktURIs.SearchUsers, HttpUtility.UrlEncode(searchTerm), maxResults), GetUserAuthentication());
-      return response.FromJSONArray<TraktUser>();
+      string response = GetFromTrakt(string.Format(TraktURIs.SearchUsers, HttpUtility.UrlEncode(searchTerm), 1, maxResults));
+      return response.FromJSONArray<TraktSearchResult>();
     }
 
     /// <summary>
     /// Returns a list of movies found using search term
     /// </summary>
-    public static IEnumerable<TraktMovie> SearchMovies(string searchTerm)
+    public static IEnumerable<TraktSearchResult> SearchMovies(string searchTerm)
     {
       return SearchMovies(searchTerm, 30);
     }
-    public static IEnumerable<TraktMovie> SearchMovies(string searchTerm, int maxResults)
+
+    public static IEnumerable<TraktSearchResult> SearchMovies(string searchTerm, int maxResults)
     {
-      string response = Transmit(string.Format(TraktURIs.SearchMovies, HttpUtility.UrlEncode(searchTerm), maxResults), GetUserAuthentication());
-      return response.FromJSONArray<TraktMovie>();
+      string response = GetFromTrakt(string.Format(TraktURIs.SearchMovies, HttpUtility.UrlEncode(searchTerm), 1, maxResults));
+      return response.FromJSONArray<TraktSearchResult>();
     }
 
     /// <summary>
     /// Returns a list of shows found using search term
     /// </summary>
-    public static IEnumerable<TraktShow> SearchShows(string searchTerm)
+    public static IEnumerable<TraktSearchResult> SearchShows(string searchTerm)
     {
       return SearchShows(searchTerm, 30);
     }
-    public static IEnumerable<TraktShow> SearchShows(string searchTerm, int maxResults)
+
+    public static IEnumerable<TraktSearchResult> SearchShows(string searchTerm, int maxResults)
     {
-      string response = Transmit(string.Format(TraktURIs.SearchShows, HttpUtility.UrlEncode(searchTerm), maxResults), GetUserAuthentication());
-      return response.FromJSONArray<TraktShow>();
+      string response = GetFromTrakt(string.Format(TraktURIs.SearchShows, HttpUtility.UrlEncode(searchTerm), 1, maxResults));
+      return response.FromJSONArray<TraktSearchResult>();
     }
 
     /// <summary>
     /// Returns a list of episodes found using search term
     /// </summary>
-    public static IEnumerable<TraktEpisodeSummary> SearchEpisodes(string searchTerm)
+    public static IEnumerable<TraktSearchResult> SearchEpisodes(string searchTerm)
     {
       return SearchEpisodes(searchTerm, 30);
     }
-    public static IEnumerable<TraktEpisodeSummary> SearchEpisodes(string searchTerm, int maxResults)
+
+    public static IEnumerable<TraktSearchResult> SearchEpisodes(string searchTerm, int maxResults)
     {
-      string response = Transmit(string.Format(TraktURIs.SearchEpisodes, HttpUtility.UrlEncode(searchTerm), maxResults), GetUserAuthentication());
-      return response.FromJSONArray<TraktEpisodeSummary>();
+      string response = GetFromTrakt(string.Format(TraktURIs.SearchEpisodes, HttpUtility.UrlEncode(searchTerm), 1, maxResults));
+      return response.FromJSONArray<TraktSearchResult>();
     }
 
     /// <summary>
     /// Returns a list of people found using search term
     /// </summary>
-    public static IEnumerable<TraktPersonSummary> SearchPeople(string searchTerm)
+    public static IEnumerable<TraktSearchResult> SearchPeople(string searchTerm)
     {
       return SearchPeople(searchTerm, 30);
     }
-    public static IEnumerable<TraktPersonSummary> SearchPeople(string searchTerm, int maxResults)
+
+    public static IEnumerable<TraktSearchResult> SearchPeople(string searchTerm, int maxResults)
     {
-      string response = Transmit(string.Format(TraktURIs.SearchPeople, HttpUtility.UrlEncode(searchTerm), maxResults), string.Empty);
-      return response.FromJSONArray<TraktPersonSummary>();
+      string response = GetFromTrakt(string.Format(TraktURIs.SearchPeople, HttpUtility.UrlEncode(searchTerm), 1, maxResults));
+      return response.FromJSONArray<TraktSearchResult>();
     }
 
-    #endregion
-
-    #region Summary
-
     /// <summary>
-    /// Returns full movie details
+    /// Returns a list of lists found using search term
     /// </summary>
-    /// <param name="id">TMDB ID, IMDB ID or slug</param>
-    /// <returns></returns>
-    public static TraktMovieSummary MovieOverview(string id)
+    public static IEnumerable<TraktSearchResult> SearchLists(string searchTerm)
+    {
+      return SearchLists(searchTerm, 30);
+    }
+
+    public static IEnumerable<TraktSearchResult> SearchLists(string searchTerm, int maxResults)
     {
-      string response = Transmit(string.Format(TraktURIs.MovieOverview, HttpUtility.UrlEncode(id)), GetUserAuthentication());
-      return response.FromJSON<TraktMovieSummary>();
+      string response = GetFromTrakt(string.Format(TraktURIs.SearchLists, HttpUtility.UrlEncode(searchTerm), 1, maxResults));
+      return response.FromJSONArray<TraktSearchResult>();
     }
 
     /// <summary>
-    /// Returns tv series details
+    /// Returns a list of items found when searching by id
     /// </summary>
-    /// <param name="id">TVDB ID or slug</param>
-    /// <param name="extended"></param>
-    /// <returns></returns>
-    public static TraktShowSummary SeriesOverview(string id, bool extended = false)
+    /// <param name="idType">trakt-movie, trakt-show, trakt-episode, imdb, tmdb, tvdb, tvrage</param>
+    /// <param name="id">the id to search by e.g. tt0848228</param>
+    public static IEnumerable<TraktSearchResult> SearchById(string idType, string id)
     {
-      string url = extended ? TraktURIs.SeriesOverviewExtended : TraktURIs.SeriesOverview;
-
-      string response = Transmit(string.Format(url, HttpUtility.UrlEncode(id)), GetUserAuthentication());
-      return response.FromJSON<TraktShowSummary>();
+      string response = GetFromTrakt(string.Format(TraktURIs.SearchById, idType, id));
+      return response.FromJSONArray<TraktSearchResult>();
     }
 
     #endregion
 
-    #region Comments
+    #region Collection
 
-    /// <summary>
-    /// Return a list of shouts for a movie
-    /// </summary>
-    /// <param name="title">The movie search term, either (title-year seperate spaces with '-'), imdbid, tmdbid</param>    
-    public static IEnumerable<TraktShout> GetMovieShouts(string title)
+    public static TraktSyncResponse AddMoviesToCollecton(TraktSyncMoviesCollected movies)
     {
-      string response = Transmit(string.Format(TraktURIs.MovieShouts, title), GetUserAuthentication());
-      return response.FromJSONArray<TraktShout>();
+      var response = PostToTrakt(TraktURIs.SyncCollectionAdd, movies.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
     }
 
-    /// <summary>
-    /// Return a list of shouts for a show
-    /// </summary>
-    /// <param name="title">The show search term, either (title seperate spaces with '-'), imdbid, tvdbid</param>    
-    public static IEnumerable<TraktShout> GetShowShouts(string title)
+    public static TraktSyncResponse RemoveMoviesFromCollecton(TraktSyncMovies movies)
     {
-      string response = Transmit(string.Format(TraktURIs.ShowShouts, title), GetUserAuthentication());
-      return response.FromJSONArray<TraktShout>();
+      var response = PostToTrakt(TraktURIs.SyncCollectionRemove, movies.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
     }
 
-    /// <summary>
-    /// Return a list of shouts for a episode
-    /// </summary>
-    /// <param name="title">The episode search term, either (title seperate spaces with '-'), imdbid, tmdbid</param>
-    /// <param name="episode">The episode index</param>
-    /// <param name="season">The season index</param>
-    public static IEnumerable<TraktShout> GetEpisodeShouts(string title, string season, string episode)
+    public static TraktSyncResponse AddShowsToCollectonEx(TraktSyncShowsEx shows)
     {
-      string response = Transmit(string.Format(TraktURIs.EpisodeShouts, title, season, episode), GetUserAuthentication());
-      return response.FromJSONArray<TraktShout>();
+      var response = PostToTrakt(TraktURIs.SyncCollectionAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
     }
 
-    #endregion
+    public static TraktSyncResponse AddShowsToCollecton(TraktSyncShows shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncCollectionAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
 
-    #region Related
+    public static TraktSyncResponse RemoveShowsFromCollecton(TraktSyncShows shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncCollectionAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
 
-    public static IEnumerable<TraktMovie> GetRelatedMovies(string title)
+    public static TraktSyncResponse AddEpisodesToCollecton(TraktSyncEpisodesCollected episodes)
     {
-      return GetRelatedMovies(title, false);
+      var response = PostToTrakt(TraktURIs.SyncCollectionAdd, episodes.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
     }
 
-    /// <summary>
-    /// Return a list of related movies for a movie
-    /// </summary>
-    /// <param name="title">The movie search term, either (title-year seperate spaces with '-'), imdbid, tmdbid</param>
-    /// <param name="hidewatched">Hide watched movies</param>
-    public static IEnumerable<TraktMovie> GetRelatedMovies(string title, bool hidewatched)
+    public static TraktSyncResponse RemoveEpisodesFromCollecton(TraktSyncEpisodes episodes)
     {
-      string response = Transmit(string.Format(TraktURIs.RelatedMovies, title, hidewatched ? "/hidewatched" : string.Empty), GetUserAuthentication());
-      return response.FromJSONArray<TraktMovie>();
+      var response = PostToTrakt(TraktURIs.SyncCollectionRemove, episodes.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
     }
 
-    public static IEnumerable<TraktShow> GetRelatedShows(string title)
+    public static TraktSyncResponse AddShowsToCollectonEx(TraktSyncShowsCollectedEx shows)
     {
-      return GetRelatedShows(title, false);
+      var response = PostToTrakt(TraktURIs.SyncCollectionAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
     }
 
-    /// <summary>
-    /// Return a list of related shows for a show
-    /// </summary>
-    /// <param name="title">The show search term, either (title-year seperate spaces with '-'), imdbid, tvdbid</param>
-    /// <param name="hidewatched">Hide watched movies</param>
-    public static IEnumerable<TraktShow> GetRelatedShows(string title, bool hidewatched)
+    public static TraktSyncResponse RemoveShowsFromCollectonEx(TraktSyncShowsEx shows)
     {
-      string response = Transmit(string.Format(TraktURIs.RelatedShows, title, hidewatched ? "/hidewatched" : string.Empty), GetUserAuthentication());
-      return response.FromJSONArray<TraktShow>();
+      var response = PostToTrakt(TraktURIs.SyncCollectionRemove, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
     }
 
     #endregion
 
-    #region Show Seasons
+    #region Collection (Single)
 
-    /// <summary>
-    /// Return a list of seasons for a tv show
-    /// </summary>
-    /// <param name="title">The show search term, either (title-year seperate spaces with '-'), imdbid, tvdbid</param>
-    public static IEnumerable<TraktShowSeason> GetShowSeasons(string title)
+    public static TraktSyncResponse AddMovieToCollection(TraktSyncMovieCollected movie)
     {
-      string response = Transmit(string.Format(TraktURIs.ShowSeasons, title), string.Empty);
-      return response.FromJSONArray<TraktShowSeason>();
+      var movies = new TraktSyncMoviesCollected
+      {
+        Movies = new List<TraktSyncMovieCollected>() { movie }
+      };
+
+      return AddMoviesToCollecton(movies);
     }
 
-    #endregion
+    public static TraktSyncResponse RemoveMovieFromCollection(TraktMovie movie)
+    {
+      var movies = new TraktSyncMovies
+      {
+        Movies = new List<TraktMovie>() { movie }
+      };
 
-    #region Season Episodes
+      return RemoveMoviesFromCollecton(movies);
+    }
 
-    /// <summary>
-    /// Return a list of episodes for a tv show season
-    /// </summary>
-    /// <param name="title">The show search term, either (title-year seperate spaces with '-'), imdbid, tvdbid</param>
-    /// <param name="season">The season, 0 for specials</param>
-    public static IEnumerable<TraktEpisode> GetSeasonEpisodes(string title, string season)
+    public static TraktSyncResponse AddShowToCollection(TraktShow show)
     {
-      string response = Transmit(string.Format(TraktURIs.SeasonEpisodes, title, season), GetUserAuthentication());
-      return response.FromJSONArray<TraktEpisode>();
+      var shows = new TraktSyncShows
+      {
+        Shows = new List<TraktShow>() { show }
+      };
+
+      return AddShowsToCollecton(shows);
     }
 
-    #endregion
+    public static TraktSyncResponse RemoveShowFromCollection(TraktShow show)
+    {
+      var shows = new TraktSyncShows
+      {
+        Shows = new List<TraktShow>() { show }
+      };
 
-    #region Helpers
+      return RemoveShowsFromCollecton(shows);
+    }
 
-    /// <summary>
-    /// Gets a User Authentication object
-    /// </summary>       
-    /// <returns>The User Authentication json string</returns>
-    private static string GetUserAuthentication()
+    public static TraktSyncResponse AddShowToCollectionEx(TraktSyncShowEx show)
     {
-      return new TraktAuthentication { Username = Username, Password = Password }.ToJSON();
+      var shows = new TraktSyncShowsEx
+      {
+        Shows = new List<TraktSyncShowEx>() { show }
+      };
+
+      return AddShowsToCollectonEx(shows);
     }
 
-    /// <summary>
-    /// Communicates to and from Trakt
-    /// </summary>
-    /// <param name="address">The URI to use</param>
-    /// <param name="data">The Data to send</param>
-    /// <returns>The response from Trakt</returns>
-    private static string Transmit(string address, string data)
+    public static TraktSyncResponse RemoveShowFromCollectionEx(TraktSyncShowEx show)
     {
-      if (OnDataSend != null) OnDataSend(address, data);
+      var shows = new TraktSyncShowsEx
+      {
+        Shows = new List<TraktSyncShowEx>() { show }
+      };
 
-      try
+      return RemoveShowsFromCollectonEx(shows);
+    }
+
+    public static TraktSyncResponse AddEpisodeToCollection(TraktSyncEpisodeCollected episode)
+    {
+      var episodes = new TraktSyncEpisodesCollected
       {
-        ServicePointManager.Expect100Continue = false;
-        WebClient client = new CompressionWebClient(true) { Encoding = Encoding.UTF8 };
-        client.Headers.Add("user-agent", UserAgent);
+        Episodes = new List<TraktSyncEpisodeCollected>() { episode }
+      };
 
-        // wait for a response from the server
-        string response = client.UploadString(address, data);
+      return AddEpisodesToCollecton(episodes);
+    }
 
-        // received data, pass it back
-        if (OnDataReceived != null) OnDataReceived(response);
-        return response;
-      }
-      catch (WebException e)
+    public static TraktSyncResponse RemoveEpisodeFromCollection(TraktEpisode episode)
+    {
+      var episodes = new TraktSyncEpisodes
       {
-        if (OnDataError != null) OnDataError(e.Message);
+        Episodes = new List<TraktEpisode>() { episode }
+      };
 
-        if (e.Status == WebExceptionStatus.ProtocolError)
-        {
-          var response = ((HttpWebResponse)e.Response);
-          try
-          {
-            using (var stream = response.GetResponseStream())
-            {
-              using (var reader = new StreamReader(stream))
-              {
-                return reader.ReadToEnd();
-              }
-            }
+      return RemoveEpisodesFromCollecton(episodes);
+    }
+
+    #endregion
+
+    #region Watched History
+
+    public static TraktSyncResponse AddMoviesToWatchedHistory(TraktSyncMoviesWatched movies)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchedHistoryAdd, movies.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveMoviesFromWatchedHistory(TraktSyncMovies movies)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchedHistoryRemove, movies.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse AddShowsToWatchedHistory(TraktSyncShows shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchedHistoryAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveShowsFromWatchedHistory(TraktSyncShows shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchedHistoryRemove, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse AddEpisodesToWatchedHistory(TraktSyncEpisodesWatched episodes)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchedHistoryAdd, episodes.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveEpisodesFromWatchedHistory(TraktSyncEpisodes episodes)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchedHistoryRemove, episodes.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse AddShowsToWatchedHistoryEx(TraktSyncShowsEx shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchedHistoryAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse AddShowsToWatchedHistoryEx(TraktSyncShowsWatchedEx shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchedHistoryAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveShowsFromWatchedHistoryEx(TraktSyncShowsEx shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchedHistoryRemove, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    #endregion
+
+    #region Watched History (Single)
+
+    public static TraktSyncResponse AddMovieToWatchedHistory(TraktSyncMovieWatched movie)
+    {
+      var movies = new TraktSyncMoviesWatched
+      {
+        Movies = new List<TraktSyncMovieWatched>() { movie }
+      };
+
+      return AddMoviesToWatchedHistory(movies);
+    }
+
+    public static TraktSyncResponse RemoveMovieFromWatchedHistory(TraktMovie movie)
+    {
+      var movies = new TraktSyncMovies
+      {
+        Movies = new List<TraktMovie>() { movie }
+      };
+
+      return RemoveMoviesFromWatchedHistory(movies);
+    }
+
+    public static TraktSyncResponse AddShowToWatchedHistory(TraktShow show)
+    {
+      var shows = new TraktSyncShows
+      {
+        Shows = new List<TraktShow>() { show }
+      };
+
+      return AddShowsToWatchedHistory(shows);
+    }
+
+    public static TraktSyncResponse RemoveShowFromWatchedHistory(TraktShow show)
+    {
+      var shows = new TraktSyncShows
+      {
+        Shows = new List<TraktShow>() { show }
+      };
+
+      return RemoveShowsFromWatchedHistory(shows);
+    }
+
+    public static TraktSyncResponse AddShowToWatchedHistoryEx(TraktSyncShowEx show)
+    {
+      var shows = new TraktSyncShowsEx
+      {
+        Shows = new List<TraktSyncShowEx>() { show }
+      };
+
+      return AddShowsToWatchedHistoryEx(shows);
+    }
+
+    public static TraktSyncResponse RemoveShowFromWatchedHistoryEx(TraktSyncShowEx show)
+    {
+      var shows = new TraktSyncShowsEx
+      {
+        Shows = new List<TraktSyncShowEx>() { show }
+      };
+
+      return RemoveShowsFromWatchedHistoryEx(shows);
+    }
+
+    public static TraktSyncResponse AddEpisodeToWatchedHistory(TraktSyncEpisodeWatched episode)
+    {
+      var episodes = new TraktSyncEpisodesWatched
+      {
+        Episodes = new List<TraktSyncEpisodeWatched>() { episode }
+      };
+
+      return AddEpisodesToWatchedHistory(episodes);
+    }
+
+    public static TraktSyncResponse RemoveEpisodeFromWatchedHistory(TraktEpisode episode)
+    {
+      var episodes = new TraktSyncEpisodes
+      {
+        Episodes = new List<TraktEpisode>() { episode }
+      };
+
+      return RemoveEpisodesFromWatchedHistory(episodes);
+    }
+
+    #endregion
+
+    #region Ratings
+
+    public static TraktSyncResponse AddMoviesToRatings(TraktSyncMoviesRated movies)
+    {
+      var response = PostToTrakt(TraktURIs.SyncRatingsAdd, movies.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveMoviesFromRatings(TraktSyncMovies movies)
+    {
+      var response = PostToTrakt(TraktURIs.SyncRatingsRemove, movies.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse AddShowsToRatings(TraktSyncShowsRated shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncRatingsAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveShowsFromRatings(TraktSyncShows shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncRatingsRemove, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse AddEpisodesToRatings(TraktSyncEpisodesRated episodes)
+    {
+      var response = PostToTrakt(TraktURIs.SyncRatingsAdd, episodes.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse AddShowsToRatingsEx(TraktSyncShowsRatedEx shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncRatingsAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse AddSeasonsToRatingsEx(TraktSyncSeasonsRatedEx shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncRatingsAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveEpisodesFromRatings(TraktSyncEpisodes episodes)
+    {
+      var response = PostToTrakt(TraktURIs.SyncRatingsRemove, episodes.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveShowsFromRatingsEx(TraktSyncShowsRatedEx shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncRatingsRemove, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveSeasonsFromRatingsEx(TraktSyncSeasonsRatedEx shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncRatingsRemove, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    #endregion
+
+    #region Ratings (Single)
+
+    /// <summary>
+    /// Rate a single episode on trakt.tv
+    /// </summary>
+    public static TraktSyncResponse AddEpisodeToRatings(TraktSyncEpisodeRated episode)
+    {
+      var episodes = new TraktSyncEpisodesRated
+      {
+        Episodes = new List<TraktSyncEpisodeRated>() { episode }
+      };
+
+      return AddEpisodesToRatings(episodes);
+    }
+
+    /// <summary>
+    /// UnRate a single episode on trakt.tv
+    /// </summary>
+    public static TraktSyncResponse RemoveEpisodeFromRatings(TraktEpisode episode)
+    {
+      var episodes = new TraktSyncEpisodes
+      {
+        Episodes = new List<TraktEpisode>() { new TraktEpisode { Ids = episode.Ids } }
+      };
+
+      return RemoveEpisodesFromRatings(episodes);
+    }
+
+    /// <summary>
+    /// Rate a single episode on trakt.tv (with show info)
+    /// </summary>
+    public static TraktSyncResponse AddEpisodeToRatingsEx(TraktSyncShowRatedEx item)
+    {
+      var episodes = new TraktSyncShowsRatedEx
+      {
+        Shows = new List<TraktSyncShowRatedEx>() { item }
+      };
+
+      return AddShowsToRatingsEx(episodes);
+    }
+
+    /// <summary>
+    /// UnRate a single episode on trakt.tv (with show info)
+    /// </summary>
+    public static TraktSyncResponse RemoveEpisodeFromRatingsEx(TraktSyncShowRatedEx item)
+    {
+      var episodes = new TraktSyncShowsRatedEx
+      {
+        Shows = new List<TraktSyncShowRatedEx>() { item }
+      };
+
+      return RemoveShowsFromRatingsEx(episodes);
+    }
+
+    /// <summary>
+    /// Rate a single season on trakt.tv (with show info)
+    /// </summary>
+    public static TraktSyncResponse AddSeasonToRatingsEx(TraktSyncSeasonRatedEx item)
+    {
+      var seasons = new TraktSyncSeasonsRatedEx
+      {
+        Shows = new List<TraktSyncSeasonRatedEx>() { item }
+      };
+
+      return AddSeasonsToRatingsEx(seasons);
+    }
+
+    /// <summary>
+    /// UnRate a single season on trakt.tv (with show info)
+    /// </summary>
+    public static TraktSyncResponse RemoveSeasonFromRatingsEx(TraktSyncSeasonRatedEx item)
+    {
+      var seasons = new TraktSyncSeasonsRatedEx
+      {
+        Shows = new List<TraktSyncSeasonRatedEx>() { item }
+      };
+
+      return RemoveSeasonsFromRatingsEx(seasons);
+    }
+
+    /// <summary>
+    /// Rate a single show on trakt.tv
+    /// </summary>
+    public static TraktSyncResponse AddShowToRatings(TraktSyncShowRated show)
+    {
+      var shows = new TraktSyncShowsRated
+      {
+        Shows = new List<TraktSyncShowRated>() { show }
+      };
+
+      return AddShowsToRatings(shows);
+    }
+
+    /// <summary>
+    /// UnRate a single show on trakt.tv
+    /// </summary>
+    public static TraktSyncResponse RemoveShowFromRatings(TraktShow show)
+    {
+      var shows = new TraktSyncShows
+      {
+        Shows = new List<TraktShow>() { new TraktShow { Ids = show.Ids } }
+      };
+
+      return RemoveShowsFromRatings(shows);
+    }
+
+    /// <summary>
+    /// Rate a single movie on trakt.tv
+    /// </summary>
+    public static TraktSyncResponse AddMovieToRatings(TraktSyncMovieRated movie)
+    {
+      var movies = new TraktSyncMoviesRated
+      {
+        Movies = new List<TraktSyncMovieRated>() { movie }
+      };
+
+      return AddMoviesToRatings(movies);
+    }
+
+    /// <summary>
+    /// UnRate a single movie on trakt.tv
+    /// </summary>
+    public static TraktSyncResponse RemoveMovieFromRatings(TraktMovie movie)
+    {
+      var movies = new TraktSyncMovies
+      {
+        Movies = new List<TraktMovie>() { new TraktMovie { Ids = movie.Ids } }
+      };
+
+      return RemoveMoviesFromRatings(movies);
+    }
+
+    #endregion
+
+    #region Community Ratings
+
+    public static TraktRating GetShowRatings(string id)
+    {
+      var response = GetFromTrakt(string.Format(TraktURIs.ShowRatings, id));
+      return response.FromJSON<TraktRating>();
+    }
+
+    public static TraktRating GetSeasonRatings(string id, int season)
+    {
+      var response = GetFromTrakt(string.Format(TraktURIs.ShowRatings, id, season));
+      return response.FromJSON<TraktRating>();
+    }
+
+    public static TraktRating GetEpisodeRatings(string id, int season, int episode)
+    {
+      var response = GetFromTrakt(string.Format(TraktURIs.EpisodeRatings, id, season, episode));
+      return response.FromJSON<TraktRating>();
+    }
+
+    #endregion
+
+    #region Scrobble
+
+    public static TraktScrobbleResponse StartMovieScrobble(TraktScrobbleMovie movie)
+    {
+      var response = PostToTrakt(TraktURIs.ScrobbleStart, movie.ToJSON());
+      return response.FromJSON<TraktScrobbleResponse>();
+    }
+
+    public static TraktScrobbleResponse StartEpisodeScrobble(TraktScrobbleEpisode episode)
+    {
+      var response = PostToTrakt(TraktURIs.ScrobbleStart, episode.ToJSON());
+      return response.FromJSON<TraktScrobbleResponse>();
+    }
+
+    public static TraktScrobbleResponse PauseMovieScrobble(TraktScrobbleMovie movie)
+    {
+      var response = PostToTrakt(TraktURIs.ScrobblePause, movie.ToJSON());
+      return response.FromJSON<TraktScrobbleResponse>();
+    }
+
+    public static TraktScrobbleResponse PauseEpisodeScrobble(TraktScrobbleEpisode episode)
+    {
+      var response = PostToTrakt(TraktURIs.ScrobblePause, episode.ToJSON());
+      return response.FromJSON<TraktScrobbleResponse>();
+    }
+
+    public static TraktScrobbleResponse StopMovieScrobble(TraktScrobbleMovie movie)
+    {
+      var response = PostToTrakt(TraktURIs.ScrobbleStop, movie.ToJSON());
+      return response.FromJSON<TraktScrobbleResponse>();
+    }
+
+    public static TraktScrobbleResponse StopEpisodeScrobble(TraktScrobbleEpisode episode)
+    {
+      var response = PostToTrakt(TraktURIs.ScrobbleStop, episode.ToJSON());
+      return response.FromJSON<TraktScrobbleResponse>();
+    }
+
+    #endregion
+
+    #region Watchlist
+
+    public static TraktSyncResponse AddMoviesToWatchlist(TraktSyncMovies movies)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchlistAdd, movies.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveMoviesFromWatchlist(TraktSyncMovies movies)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchlistRemove, movies.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse AddShowsToWatchlist(TraktSyncShows shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchlistAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse AddShowsToWatchlistEx(TraktSyncShowsEx shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchlistAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveShowsFromWatchlist(TraktSyncShows shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchlistRemove, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveShowsFromWatchlistEx(TraktSyncShowsEx shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchlistRemove, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse AddSeasonsToWatchlist(TraktSyncSeasonsEx shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchlistAdd, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveSeasonsFromWatchlist(TraktSyncSeasonsEx shows)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchlistRemove, shows.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse AddEpisodesToWatchlist(TraktSyncEpisodes episodes)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchlistAdd, episodes.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    public static TraktSyncResponse RemoveEpisodesFromWatchlist(TraktSyncEpisodes episodes)
+    {
+      var response = PostToTrakt(TraktURIs.SyncWatchlistRemove, episodes.ToJSON());
+      return response.FromJSON<TraktSyncResponse>();
+    }
+
+    #endregion
+
+    #region Watchlist (Single)
+
+    public static TraktSyncResponse AddMovieToWatchlist(TraktMovie movie)
+    {
+      var movies = new TraktSyncMovies
+      {
+        Movies = new List<TraktMovie>() { movie }
+      };
+
+      return AddMoviesToWatchlist(movies);
+    }
+
+    public static TraktSyncResponse RemoveMovieFromWatchlist(TraktMovie movie)
+    {
+      var movies = new TraktSyncMovies
+      {
+        Movies = new List<TraktMovie>() { movie }
+      };
+
+      return RemoveMoviesFromWatchlist(movies);
+    }
+
+    public static TraktSyncResponse AddShowToWatchlist(TraktShow show)
+    {
+      var shows = new TraktSyncShows
+      {
+        Shows = new List<TraktShow>() { show }
+      };
+
+      return AddShowsToWatchlist(shows);
+    }
+
+    public static TraktSyncResponse AddShowToWatchlistEx(TraktSyncShowEx show)
+    {
+      var shows = new TraktSyncShowsEx
+      {
+        Shows = new List<TraktSyncShowEx>() { show }
+      };
+
+      return AddShowsToWatchlistEx(shows);
+    }
+
+    public static TraktSyncResponse AddSeasonToWatchlist(TraktSyncSeasonEx show)
+    {
+      var shows = new TraktSyncSeasonsEx
+      {
+        Shows = new List<TraktSyncSeasonEx>() { show }
+      };
+
+      return AddSeasonsToWatchlist(shows);
+    }
+
+    public static TraktSyncResponse RemoveSeasonFromWatchlist(TraktSyncSeasonEx show)
+    {
+      var shows = new TraktSyncSeasonsEx
+      {
+        Shows = new List<TraktSyncSeasonEx>() { show }
+      };
+
+      return RemoveSeasonsFromWatchlist(shows);
+    }
+
+    public static TraktSyncResponse RemoveShowFromWatchlist(TraktShow show)
+    {
+      var shows = new TraktSyncShows
+      {
+        Shows = new List<TraktShow>() { show }
+      };
+
+      return RemoveShowsFromWatchlist(shows);
+    }
+
+    public static TraktSyncResponse RemoveShowFromWatchlistEx(TraktSyncShowEx show)
+    {
+      var shows = new TraktSyncShowsEx
+      {
+        Shows = new List<TraktSyncShowEx>() { show }
+      };
+
+      return RemoveShowsFromWatchlistEx(shows);
+    }
+
+    public static TraktSyncResponse AddEpisodeToWatchlist(TraktEpisode episode)
+    {
+      var episodes = new TraktSyncEpisodes
+      {
+        Episodes = new List<TraktEpisode>() { episode }
+      };
+
+      return AddEpisodesToWatchlist(episodes);
+    }
+
+    public static TraktSyncResponse RemoveEpisodeFromWatchlist(TraktEpisode episode)
+    {
+      var episodes = new TraktSyncEpisodes
+      {
+        Episodes = new List<TraktEpisode>() { episode }
+      };
+
+      return RemoveEpisodesFromWatchlist(episodes);
+    }
+
+    #endregion
+
+    #region Comments
+
+    public static bool LikeComment(int id)
+    {
+      var response = PostToTrakt(string.Format(TraktURIs.CommentLike, id), null);
+      return response != null;
+    }
+
+    public static bool UnLikeComment(int id)
+    {
+      return DeleteFromTrakt(string.Format(TraktURIs.CommentLike, id));
+    }
+
+    public static IEnumerable<TraktComment> GetCommentReplies(string id)
+    {
+      var response = GetFromTrakt(string.Format(TraktURIs.CommentReplies, id));
+      return response.FromJSONArray<TraktComment>();
+    }
+
+    #endregion
+
+    #region People
+
+    public static TraktPersonSummary GetPersonSummary(string person)
+    {
+      var response = GetFromTrakt(string.Format(TraktURIs.PersonSummary, person));
+      return response.FromJSON<TraktPersonSummary>();
+    }
+
+    public static TraktPersonMovieCredits GetMovieCreditsForPerson(string person)
+    {
+      var response = GetFromTrakt(string.Format(TraktURIs.PersonMovieCredits, person));
+      return response.FromJSON<TraktPersonMovieCredits>();
+    }
+
+    public static TraktPersonShowCredits GetShowCreditsForPerson(string person)
+    {
+      var response = GetFromTrakt(string.Format(TraktURIs.PersonShowCredits, person));
+      return response.FromJSON<TraktPersonShowCredits>();
+    }
+
+    #endregion
+
+    #region Web Helpers
+
+    private static string ReplaceOnTrakt(string address, string postData)
+    {
+      return PostToTrakt(address, postData, true, "PUT");
+    }
+
+    private static bool DeleteFromTrakt(string address)
+    {
+      var response = GetFromTrakt(address, "DELETE");
+      return response != null;
+    }
+
+    private static string GetFromTrakt(string address, string method = "GET", bool sendOAuth = true)
+    {
+      WebHeaderCollection headerCollection;
+      return GetFromTrakt(address, out headerCollection, method, sendOAuth);
+    }
+
+    private static string GetFromTrakt(string address, out WebHeaderCollection headerCollection, string method = "GET", bool sendOAuth = true)
+    {
+      headerCollection = new WebHeaderCollection();
+
+      if (UseSSL)
+      {
+        ServicePointManager.Expect100Continue = true;
+        ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls;
+      }
+      else
+      {
+        address = address.Replace("https://", "http://");
+      }
+
+      if (OnDataSend != null)
+        OnDataSend(address, null);
+
+      Stopwatch watch;
+
+      var request = WebRequest.Create(address) as HttpWebRequest;
+
+      request.KeepAlive = true;
+      request.Method = method;
+      request.ContentLength = 0;
+      request.Timeout = 120000;
+      request.ContentType = "application/json";
+      request.UserAgent = UserAgent;
+
+      // add required headers for authorisation
+      request.Headers.Add("trakt-api-version", "2");
+      request.Headers.Add("trakt-api-key", ApplicationId);
+
+      // some methods we may want to get all data and not filtered by user data
+      // e.g. Calendar - All Shows
+      if (sendOAuth)
+      {
+        request.Headers.Add("trakt-user-login", Username ?? string.Empty);
+        request.Headers.Add("trakt-user-token", UserToken ?? string.Empty);
+      }
+
+      // measure how long it took to get a response
+      watch = Stopwatch.StartNew();
+
+      try
+      {
+        HttpWebResponse response = (HttpWebResponse)request.GetResponse();
+        if (response == null)
+        {
+          watch.Stop();
+          return null;
+        }
+
+        Stream stream = response.GetResponseStream();
+        watch.Stop();
+
+        StreamReader reader = new StreamReader(stream);
+        string strResponse = reader.ReadToEnd();
+
+        headerCollection = response.Headers;
+
+        if (method == "DELETE")
+        {
+          strResponse = response.StatusCode == HttpStatusCode.NoContent ? "Item Deleted" : "Failed to delete item";
+        }
+
+        if (OnDataReceived != null)
+          OnDataReceived(strResponse, response);
+
+        if (OnLatency != null)
+          OnLatency(watch.Elapsed.TotalMilliseconds, response, 0, strResponse.Length * sizeof (Char));
+
+        stream.Close();
+        reader.Close();
+        response.Close();
+
+        return strResponse;
+      }
+      catch (WebException wex)
+      {
+        watch.Stop();
+
+        string errorMessage = wex.Message;
+        if (wex.Status == WebExceptionStatus.ProtocolError)
+        {
+          var response = wex.Response as HttpWebResponse;
+
+          string headers = string.Empty;
+          foreach (string key in response.Headers.AllKeys)
+          {
+            headers += string.Format("{0}: {1}, ", key, response.Headers[key]);
           }
-          catch { }
+          errorMessage = string.Format("Protocol Error, Code = '{0}', Description = '{1}', Url = '{2}', Headers = '{3}'", (int)response.StatusCode, response.StatusDescription, address, headers.TrimEnd(new char[] { ',', ' ' }));
+
+          if (OnLatency != null)
+            OnLatency(watch.Elapsed.TotalMilliseconds, response, 0, 0);
         }
 
-        // create a proper response object
-        TraktResponse error = new TraktResponse
+        if (OnDataError != null)
+          OnDataError(errorMessage);
+
+        return null;
+      }
+      catch (IOException ioe)
+      {
+        string errorMessage = string.Format("Request failed due to an IO error, Description = '{0}', Url = '{1}', Method = '{2}'", ioe.Message, address, method);
+
+        if (OnDataError != null)
+          OnDataError(ioe.Message);
+
+        return null;
+      }
+    }
+
+    private static string PostToTrakt(string address, string postData, bool logRequest = true, string method = "POST")
+    {
+      if (UseSSL)
+      {
+        ServicePointManager.Expect100Continue = true;
+        ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls;
+      }
+      else
+      {
+        address = address.Replace("https://", "http://");
+      }
+
+      if (OnDataSend != null && logRequest)
+        OnDataSend(address, postData);
+
+      Stopwatch watch;
+
+      if (postData == null)
+        postData = string.Empty;
+
+      byte[] data = new UTF8Encoding().GetBytes(postData);
+
+      var request = WebRequest.Create(address) as HttpWebRequest;
+      request.KeepAlive = true;
+
+      request.Method = method;
+      request.ContentLength = data.Length;
+      request.Timeout = 120000;
+      request.ContentType = "application/json";
+      request.UserAgent = UserAgent;
+
+      // add required headers for authorisation
+      request.Headers.Add("trakt-api-version", "2");
+      request.Headers.Add("trakt-api-key", ApplicationId);
+
+      // if we're logging in, we don't need to add these headers
+      if (!string.IsNullOrEmpty(UserToken))
+      {
+        request.Headers.Add("trakt-user-login", Username);
+        request.Headers.Add("trakt-user-token", UserToken);
+      }
+
+      // measure how long it took to get a response
+      watch = Stopwatch.StartNew();
+
+      try
+      {
+        // post to trakt
+        Stream postStream = request.GetRequestStream();
+        postStream.Write(data, 0, data.Length);
+
+        // get the response
+        var response = (HttpWebResponse)request.GetResponse();
+        watch.Stop();
+
+        if (response == null)
+          return null;
+
+        Stream responseStream = response.GetResponseStream();
+        var reader = new StreamReader(responseStream);
+        string strResponse = reader.ReadToEnd();
+
+        if (string.IsNullOrEmpty(strResponse))
         {
-          Status = "failure",
-          Error = e.Message
-        };
-        return error.ToJSON();
+          strResponse = response.StatusCode.ToString();
+        }
+
+        if (OnDataReceived != null)
+          OnDataReceived(strResponse, response);
+
+        if (OnLatency != null)
+          OnLatency(watch.Elapsed.TotalMilliseconds, response, postData.Length * sizeof (Char), strResponse.Length * sizeof (Char));
+
+        // cleanup
+        postStream.Close();
+        responseStream.Close();
+        reader.Close();
+        response.Close();
+
+        return strResponse;
+      }
+      catch (WebException ex)
+      {
+        watch.Stop();
+
+        string result = null;
+        string errorMessage = ex.Message;
+        if (ex.Status == WebExceptionStatus.ProtocolError)
+        {
+          var response = ex.Response as HttpWebResponse;
+
+          string headers = string.Empty;
+          foreach (string key in response.Headers.AllKeys)
+          {
+            headers += string.Format("{0}: {1}, ", key, response.Headers[key]);
+          }
+          errorMessage = string.Format("Protocol Error, Code = '{0}', Description = '{1}', Url = '{2}', Headers = '{3}'", (int)response.StatusCode, response.StatusDescription, address, headers.TrimEnd(new char[] { ',', ' ' }));
+
+          result = new TraktStatus { Code = (int)response.StatusCode, Description = response.StatusDescription }.ToJSON();
+
+          if (OnLatency != null)
+            OnLatency(watch.Elapsed.TotalMilliseconds, response, postData.Length * sizeof (Char), 0);
+        }
+
+        if (OnDataError != null)
+          OnDataError(errorMessage);
+
+        return result;
+      }
+      catch (IOException ioe)
+      {
+        string errorMessage = string.Format("Request failed due to an IO error, Description = '{0}', Url = '{1}', Method = '{2}'", ioe.Message, address, method);
+
+        if (OnDataError != null)
+          OnDataError(ioe.Message);
+
+        return null;
       }
     }
 
     #endregion
+
+    #endregion
   }
-}
+}
\ No newline at end of file
